Unicode Stringshare

Functions
Unicode Stringshare
Eina » Data Types

These functions allow you to store one copy of a string, and use it throughout your program. More...

## Functions
const Eina_Unicode * | eina_ustringshare_add_length (const Eina_Unicode *str, unsigned int slen)
| Retrieve an instance of a string for use in a program. More...
const Eina_Unicode * | eina_ustringshare_add (const Eina_Unicode *str)
| Retrieve an instance of a string for use in a program. More...
const Eina_Unicode * | eina_ustringshare_ref (const Eina_Unicode *str)
| Increment references of the given shared string. More...
void | eina_ustringshare_del (const Eina_Unicode *str)
| Note that the given string has lost an instance. More...
int | eina_ustringshare_strlen (const Eina_Unicode *str)
| Note that the given string must be shared. More...
void | eina_ustringshare_dump (void)
| Dump the contents of the share_common. More...
static Eina_Bool | eina_ustringshare_replace (const Eina_Unicode **p_str, const Eina_Unicode *news)
static Eina_Bool | eina_ustringshare_replace_length (const Eina_Unicode **p_str, const Eina_Unicode *news, unsigned int slen)

## Detailed Description

These functions allow you to store one copy of a string, and use it throughout your program.

This is a method to reduce the number of duplicated strings kept in memory. It's pretty common for the same strings to be dynamically allocated repeatedly between applications and libraries, especially in circumstances where you could have multiple copies of a structure that allocates the string. So rather than duplicating and freeing these strings, you request a read-only pointer to an existing string and only incur the overhead of a hash lookup.

It sounds like micro-optimizing, but profiling has shown this can have a significant impact as you scale the number of copies up. It improves string creation/destruction speed, reduces memory use and decreases memory fragmentation, so a win all-around.

For more information, you can look at the UStringshare Tutorial.

## Function Documentation

## ◆ eina_ustringshare_add_length()

const Eina_Unicode* eina_ustringshare_add_length | ( | const Eina_Unicode * | str,
|  | unsigned int | slen
| ) |  |

Retrieve an instance of a string for use in a program.

Parameters

  str | The string to retrieve an instance of.
  slen | The string size (<= strlen(str)).

Returns
  A pointer to an instance of the string on success. `NULL` on failure.

This function retrieves an instance of `str`. If `str` is `NULL`, then `NULL` is returned. If `str` is already stored, it is just returned and its reference counter is increased. Otherwise it is added to the strings to be searched and a duplicated string of `str` is returned.

This function does not check string size, but uses the exact given size. This can be used to share_common part of a larger buffer or substring.

See also
  eina_ustringshare_add()

## ◆ eina_ustringshare_add()

const Eina_Unicode* eina_ustringshare_add | ( | const Eina_Unicode * | str | ) |

Retrieve an instance of a string for use in a program.

Parameters

  str | The NULL-terminated string to retrieve an instance of.

Returns
  A pointer to an instance of the string on success. `NULL` on failure.

This function retrieves an instance of `str`. If `str` is `NULL`, then `NULL` is returned. If `str` is already stored, it is just returned and its reference counter is increased. Otherwise it is added to the strings to be searched and a duplicated string of `str` is returned.

The string `str` must be NULL-terminated ('\0') and its full length will be used. To use part of the string or non-null terminated, use eina_stringshare_add_length() instead.

See also
  eina_ustringshare_add_length()

## ◆ eina_ustringshare_ref()

const Eina_Unicode* eina_ustringshare_ref | ( | const Eina_Unicode * | str | ) |

Increment references of the given shared string.

Parameters

  str | The shared string.

Returns
  A pointer to an instance of the string on success. `NULL` on failure.

This is similar to eina_share_common_add(), but it's faster since it will avoid lookups if possible, but on the down side it requires the parameter to be shared before, in other words, it must be the return of a previous eina_ustringshare_add().

There is no unref since this is the work of eina_ustringshare_del().

## ◆ eina_ustringshare_del()

void eina_ustringshare_del | ( | const Eina_Unicode * | str | ) |

Note that the given string has lost an instance.

Parameters

  str | string The given string.

This function decreases the reference counter associated to `str` if it exists. If that counter reaches 0, the memory associated to `str` is freed. If `str` is `NULL`, the function returns immediately.

Note
  If the given pointer is not shared, bad things will happen, likely a segmentation fault.

## ◆ eina_ustringshare_strlen()

int eina_ustringshare_strlen | ( | const Eina_Unicode * | str | ) |

Note that the given string must be shared.

Parameters

  str | the shared string to know the length. It is safe to give `NULL`, in that case `-1` is returned.

This function is a cheap way to known the length of a shared string.

Note
  If the given pointer is not shared, bad things will happen, likely a segmentation fault. If in doubt, try strlen().

## ◆ eina_ustringshare_dump()

void eina_ustringshare_dump | ( | void |  | ) |

Dump the contents of the share_common.

This function dumps all strings in the share_common to stdout with a DDD: prefix per line and a memory usage summary.